"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Model = void 0;
const descriptors_1 = require("../../descriptors");
require("reflect-metadata");
const string_1 = require("@agape/string");
function Model(...args) {
    var _a;
    // determine the target class and the descriptor parameters from the
    // arguments supplied to the @Model descriptor, this allows the
    // descriptor to be called as either @Model or @Model(params)
    let target;
    let token;
    let params;
    if (args.length) {
        if (args[0] instanceof Function) {
            [target] = args;
        }
        else if (typeof args[0] === 'string') {
            [token, params] = args;
            params !== null && params !== void 0 ? params : (params = {});
            (_a = params.token) !== null && _a !== void 0 ? _a : (params.token = token);
        }
        else {
            [params] = args;
        }
        args[0] instanceof Function
            ? [target] = args
            : [params] = args;
    }
    function Model(target) {
        var _a, _b;
        params !== null && params !== void 0 ? params : (params = {});
        if (params.token && params.name === undefined) {
            params.name = (0, string_1.camelize)(params.token);
        }
        (_a = params.name) !== null && _a !== void 0 ? _a : (params.name = target.name);
        (_b = params.symbol) !== null && _b !== void 0 ? _b : (params.symbol = target.name);
        // A stub model descriptor may have been created by a @Field decorator
        // this happens because the @Field decorators are executed before the
        // @Model decorator is called. If a descriptor exist, retrieve it from
        // the reflect metadata and apply any parameters passed to the @Model decorator
        let descriptor = Reflect.getMetadata("model:descriptor", target.prototype);
        if (descriptor) {
            // Copy in params
            Object.assign(descriptor, params);
            // Autopopulate empty label/token values
            descriptor.autopopulate();
        }
        // If a model descriptor does not already exist, create one using the
        // parameters applied to the @Model decorator
        else {
            descriptor = new descriptors_1.ModelDescriptor(params);
        }
        Reflect.defineMetadata("model:descriptor", descriptor, target);
    }
    if (target)
        return Model(target);
    else
        return Model;
}
exports.Model = Model;
Model.descriptor = function (target, create = false) {
    let descriptor = Reflect.getMetadata("model:descriptor", target);
    if (!descriptor && create === true) {
        descriptor = new descriptors_1.ModelDescriptor();
        Reflect.defineMetadata("model:descriptor", descriptor, target);
    }
    return descriptor;
};
//# sourceMappingURL=model.js.map