"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForeignKey = void 0;
const field_1 = require("./field");
function ForeignKey(...args) {
    // Determine the target and parameters to be passed to the FieldDescriptor based
    // on arguments supplied to the @ForeignKey decorator, this allows the decorator to
    // be used as either @ForeignKey or @ForeignKey(params)
    let target;
    let name;
    let params;
    let foreignDocument;
    let propertyDescriptor;
    args.length === 3
        ? [target, name, propertyDescriptor] = args
        : [foreignDocument, params] = args;
    params !== null && params !== void 0 ? params : (params = {});
    params['foreignKey'] = true;
    params['foreignDocument'] = foreignDocument;
    function ForeignKey(target, name, propertyDescriptor) {
        if (propertyDescriptor)
            throw new Error("Cannot use the ForeignKey decorator on a method");
        (0, field_1.Field)(params)(target, name, propertyDescriptor);
    }
    if (target)
        return ForeignKey(target, name, propertyDescriptor);
    else
        return ForeignKey;
}
exports.ForeignKey = ForeignKey;
//# sourceMappingURL=foreign-key.js.map