"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Primary = void 0;
const field_1 = require("./field");
function Primary(...args) {
    // Determine the target and parameters to be passed to the FieldDescriptor based
    // on arguments supplied to the @Primary decorator, this allows the decorator to
    // be used as either @Primary or @Primary(params)
    let target;
    let name;
    let params;
    let propertyDescriptor;
    args.length === 1
        ? [params] = args
        : [target, name, propertyDescriptor] = args;
    params !== null && params !== void 0 ? params : (params = {});
    params['primary'] = true;
    function Primary(target, name, propertyDescriptor) {
        if (propertyDescriptor)
            throw new Error("Cannot use the Primary decorator on a method");
        (0, field_1.Field)(params)(target, name, propertyDescriptor);
        // let model = Model.descriptor(target, true)
        // model.field(name).assign(params)
    }
    if (target)
        return Primary(target, name, propertyDescriptor);
    else
        return Primary;
}
exports.Primary = Primary;
//# sourceMappingURL=primary.js.map