"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Required = void 0;
const model_1 = require("../class/model");
function Required(...args) {
    // Determine the target and parameters to be passed to the FieldDescriptor based
    // on arguments supplied to the @Required decorator, this allows the decorator to
    // be used as either @Required or @Required(params)
    let target;
    let name;
    let params = { required: true };
    let propertyDescriptor;
    args.length === 1
        ? [params] = args
        : [target, name, propertyDescriptor] = args;
    function Required(target, name, propertyDescriptor) {
        if (propertyDescriptor)
            throw new Error("Cannot use the Required decorator on a method");
        let model = model_1.Model.descriptor(target, true);
        model.field(name).assign(params);
    }
    if (target)
        return Required(target, name, propertyDescriptor);
    else
        return Required;
}
exports.Required = Required;
//# sourceMappingURL=required.js.map